compile_mode :pop11 +strict;

section;

;;; Insert V so that it begins at N in X.  Lovely equation :-
;;;     X = splice( cut( A, B, X ), A, allbutcut( A, B, X ) )

;;;  1 <= N <= L + 1, upper range for N
;;; -L <= N <= 0,     lower range for N

define global constant procedure splice( V, N, X );

    unless isinteger( N ) do
       N or 1 -> N;
       unless isinteger( N ) do
           mishap( N, 1, 'Index out of range' )
       endunless
    endunless;

    if isvectorclass( X ) then
        lvars L = datalength( X );
        if N fi_<= 0 then
            N fi_+ 1 fi_+ L -> N
        endif;
        lvars key = datakey( X );
        lvars procedure subscr = class_fast_subscr( key );
        class_cons( key )(#|
            lvars j;
            fast_for j from 1 to fi_check( N fi_- 1, 0, L ) do
                subscr( j, X )
            endfor;
            explode( V );
            fast_for j from N to L do
                subscr( j, X )
            endfor
        |#)
    elseif islist( X ) then
        if N == 0 then
            ;;; Avoid computing listlength in this special case.
            [% dl( X ); explode( V ) %]
        else
            if N fi_< 0 then
                N fi_+ listlength( X ) fi_+ 1 -> N;
            endif;
            popstackmark;
            fast_repeat fi_check( N fi_- 1, 0, false ) times 
                dest( X ) -> X 
            endrepeat;
            explode( V );
            sysconslist_onto( X );
        endif
    elseif isword( X ) then
        consword( splice( V, N, fast_word_string( X ) ) )
    else
        mishap( X, 1, 'Invalid item for insert' )
    endif
enddefine;

endsection;

